diff -ruN freeswan-1.9.orig/pluto/ipsec_doi.c freeswan-1.9/pluto/ipsec_doi.c
--- freeswan-1.9.orig/pluto/ipsec_doi.c	Sun Jan 28 16:03:04 2001
+++ freeswan-1.9/pluto/ipsec_doi.c	Thu May 17 11:09:08 2001
@@ -1895,50 +2320,270 @@
 stf_status
 main_inR1_outI2(struct msg_digest *md)
 {
-    struct state *const st = md->st;
-
-    /* verify echoed SA */
-    {
-	struct payload_digest *const sapd = md->chain[ISAKMP_NEXT_SA];
-
-	RETURN_STF_FAILURE(parse_isakmp_sa_body(&sapd->pbs
-	    , &sapd->payload.sa, NULL, TRUE, st));
-    }
+  struct state *const st = md->st;
+#ifdef OPENSSL
+  u_int8_t np;
+#endif
 
+  DBG(DBG_PARSING,
+  DBG_log("in main_inR1_outI2");
+  );
+
+  /* verify echoed SA */
+  {
+    struct payload_digest *const sapd = md->chain[ISAKMP_NEXT_SA];
+
+    RETURN_STF_FAILURE(parse_isakmp_sa_body(&sapd->pbs, 
+      &sapd->payload.sa, NULL, TRUE, st));
+  }
+
+  /* 
+   * Here, we have to decide if the outgoing packet is going to be created 
+   * for the classic RSASIG, or the OPENSSL functions.
+   */
+#ifdef OPENSSL
+  if (!use_openssl(st->st_connection)) 
+  {
+#endif
     /**************** build output packet HDR;KE;Ni ****************/
 
     /* HDR out.
      * We can't leave this to comm_handle() because the isa_np
      * depends on the type of Auth (eventually).
      */
+
     {
-	struct isakmp_hdr r_hdr = md->hdr;
+      struct isakmp_hdr r_hdr = md->hdr;
 
-	r_hdr.isa_np = ISAKMP_NEXT_KE;
-	if (!out_struct(&r_hdr, &isakmp_hdr_desc, &md->reply, &md->rbody))
-	    return STF_INTERNAL_ERROR;
+      r_hdr.isa_np = ISAKMP_NEXT_KE;
+      if (!out_struct(&r_hdr, &isakmp_hdr_desc, &md->reply, &md->rbody))
+        return STF_INTERNAL_ERROR;
     }
 
     /* KE out */
-    if (!build_and_ship_KE(st, &st->st_gi, st->st_oakley.group
-    , &md->rbody, ISAKMP_NEXT_NONCE))
-	return STF_INTERNAL_ERROR;
-
+    if (!build_and_ship_KE(st, &st->st_gi, st->st_oakley.group, 
+      &md->rbody, ISAKMP_NEXT_NONCE))
+      return STF_INTERNAL_ERROR;
+    
     /* Ni out */
     if (!build_and_ship_nonce(&st->st_ni, &md->rbody, ISAKMP_NEXT_NONE, "Ni"))
+      return STF_INTERNAL_ERROR;
+
+#ifdef OPENSSL
+  }
+  else /* use_openssl == TRUE */
+  {
+    DBG(DBG_PARSING, 
+    DBG_log("main_inR1_outI2: auth chosen is %s",
+      enum_show(&oakley_auth_names, st->st_oakley.auth));
+    );
+
+    if ((st->st_oakley.auth == OAKLEY_RSA_ENC_REV) ||
+      (st->st_oakley.auth == OAKLEY_ELGAMAL_ENC_REV)) {
+      struct isakmp_hdr r_hdr = md->hdr;
+
+      /* HDR out */
+      r_hdr.isa_np = ISAKMP_NEXT_NONCE;
+      if (!out_struct(&r_hdr, &isakmp_hdr_desc, &md->reply, &md->rbody))
+        return STF_INTERNAL_ERROR;
+      
+      if (!build_and_ship_nonce_pk(st, &st->st_ni, &md->rbody,
+        ISAKMP_NEXT_KE, "<Ni_b>PubKey_r"))
+        return STF_INTERNAL_ERROR;
+
+      if (derive_symmetric_key(st, st->st_ni,
+        st->st_icookie, COOKIE_SIZE,
+        &st->st_ks_i,
+        &st->st_ne_i) < 0) {
+	log("error while deriving symmetric key in revised mode");
 	return STF_INTERNAL_ERROR;
+      }
+      memset(st->st_ne_i_iv, 0, MAX_DIGEST_LEN);
+      DBG(DBG_PARSING,
+      DBG_dump_chunk("Generated Ke_i:", st->st_ne_i);
+      );
+
+      /* KE out */
+      if (!build_and_ship_KE_rpk(st, TRUE, &st->st_gi, st->st_oakley.group,
+        &md->rbody, ISAKMP_NEXT_ID))
+        return STF_INTERNAL_ERROR;
+
+      /* <IDi1_b>Ke_i,[<cert>Ke_i] out */
+      {
+        chunk_t ch, out;
+
+        /*
+         * Switch for different ID types to send
+         */
+	if (st->st_connection->this.id.kind == ID_DER_ASN1_DN) {
+          ch.len = st->st_connection->this.id.der_asn1_dn.len + 4;
+          ch.ptr = alloc_bytes(ch.len, "encrypted der_asn1_dn identity");
+          ch.ptr[0] = (u_int8_t)st->st_connection->this.id.kind;
+          memset(&(ch.ptr[1]), 0, 1);
+          memset(&(ch.ptr[2]), 0, 2);
+          memcpy(&(ch.ptr[4]), 
+            st->st_connection->this.id.der_asn1_dn.ptr, 
+            st->st_connection->this.id.der_asn1_dn.len);
+        } else {
+          ch.len = sizeof(st->st_connection->this.id.ip_addr) + 4;
+          ch.ptr = alloc_bytes(ch.len, "encrypted identity");
+          ch.ptr[0] = (u_int8_t)st->st_connection->this.id.kind;
+          memset(&(ch.ptr[1]), 0, 1);
+          memset(&(ch.ptr[2]), 0, 2);
+          memcpy(&(ch.ptr[4]), &(st->st_connection->this.id.ip_addr), 
+            sizeof(st->st_connection->this.id.ip_addr));
+	}
 
-    /* finish message */
-    close_message(&md->rbody);
+        if (!encrypt_payload(st, &st->st_ks_i, st->st_ne_i_iv,
+          ch, &out))
+          return STF_INTERNAL_ERROR;
+        freeanychunk(ch);
+
+        /* Are we going to send CERT? */
+        if ((st->st_connection->cert_options & CERT_OPTION_SEND) == 0) {
+          if (!out_generic_chunk(ISAKMP_NEXT_NONE, &isakmp_generic_desc,
+            &md->rbody, out, "my identity (ciphertext)")) 
+          {
+            freeanychunk(out);
+            return STF_INTERNAL_ERROR;
+          }
+        } else {
+          if (!out_generic_chunk(ISAKMP_NEXT_CERT, &isakmp_generic_desc,
+            &md->rbody, out, "my identity (ciphertext)")) 
+          {
+            freeanychunk(out);
+            return STF_INTERNAL_ERROR;
+          }
+        }
+
+        /* Well, if we do send CERT, let's start on it from here */
+        if ((st->st_connection->cert_options & CERT_OPTION_SEND) != 0) {
+          chunk_t crt, cx;
+          unsigned long ulen;
+          /* Send the signing certificate */
+
+          ulen = i2d_X509(st->st_connection->cert, NULL);
+          ulen++;
+          if ((cx.ptr = alloc_bytes(ulen, "ASN.1 cert")) == NULL)
+          { 
+            return STF_INTERNAL_ERROR; 
+          }
+          (cx.ptr)[0] = (u_char)(CERT_TYPE_X509_SIG);
+          cx.len = ulen;
+          crt.ptr = &(cx.ptr[1]);
+          crt.len = i2d_X509(st->st_connection->cert, &(crt.ptr));
+
+          DBG(DBG_CRYPT,
+          DBG_log("plaintext Certificate length: %d", cx.len);
+          DBG_dump_chunk("plaintext Certificate", cx);
+          );
+
+          /* encrypt the certificate to send */
+          if (!encrypt_payload(st, &st->st_ks_i, st->st_ne_i_iv,
+            cx, &out))
+          return STF_INTERNAL_ERROR;
+
+          DBG(DBG_CRYPT,
+          DBG_log("cyphertext Certificate length: %d", out.len);
+          DBG_dump_chunk("cyphertext Certificate", out);
+          );
+
+          if (!out_generic_chunk(ISAKMP_NEXT_NONE, 
+            &isakmp_ipsec_certificate_desc,
+            &md->rbody, out, "my certificate (ciphertext)")) 
+          {
+            freeanychunk(out);
+            return STF_INTERNAL_ERROR;
+          }
+        }
+        /* end of sending out cert */
+
+        freeanychunk(out);
+      }
+    } else {
+      struct isakmp_hdr r_hdr = md->hdr;
+      
+      r_hdr.isa_np = ISAKMP_NEXT_KE;
+      if (!out_struct(&r_hdr, &isakmp_hdr_desc, &md->reply, &md->rbody))
+        return STF_INTERNAL_ERROR;
+
+      if ((st->st_oakley.auth == OAKLEY_RSA_ENC) ||
+        (st->st_oakley.auth == OAKLEY_ELGAMAL_ENC))
+        np = ISAKMP_NEXT_ID;
+      else /* Digital Sig or Preshared key */
+        np = ISAKMP_NEXT_NONCE;
+      
+      /* KE out */
+      if (!build_and_ship_KE(st, &st->st_gi, st->st_oakley.group, 
+        &md->rbody, np))
+        return STF_INTERNAL_ERROR;
+      
+      if ((st->st_oakley.auth == OAKLEY_RSA_ENC) ||
+	  (st->st_oakley.auth == OAKLEY_ELGAMAL_ENC)) {
+
+	/* <IDii_b>PubKey_r out */
+	chunk_t ch;
+
+        /* Switch for different ID types to send */
+        if (st->st_connection->this.id.kind == ID_DER_ASN1_DN) {
+          ch.len = st->st_connection->this.id.der_asn1_dn.len + 4;
+          ch.ptr = alloc_bytes(ch.len, "plaintext der_asn1_dn identity");
+          ch.ptr[0] = (u_int8_t)st->st_connection->this.id.kind;
+          memset(&(ch.ptr[1]), 0, 1);
+          memset(&(ch.ptr[2]), 0, 2);
+          memcpy(&(ch.ptr[4]), 
+            st->st_connection->this.id.der_asn1_dn.ptr, 
+            st->st_connection->this.id.der_asn1_dn.len);
+        } else {
+          ch.len = sizeof(st->st_connection->this.id.ip_addr) + 4;
+          ch.ptr = alloc_bytes(ch.len, "my identity (plaintext)");
+          ch.ptr[0] = (u_int8_t)st->st_connection->this.id.kind;
+          memset(&(ch.ptr[1]), 0, 1);
+          memset(&(ch.ptr[2]), 0, 2);
+          memcpy(&(ch.ptr[4]), &(st->st_connection->this.id.ip_addr), 
+            sizeof(st->st_connection->this.id.ip_addr));
+        }
+
+        /* PK encrypt this */
+        if (! pubkey_encrypt_chunk( &ch, st )) {
+          return STF_INTERNAL_ERROR;
+        }
+        if (!out_generic_chunk(ISAKMP_NEXT_NONCE, &isakmp_generic_desc,
+          &md->rbody, ch, "my identity (ciphertext)"))
+        return STF_INTERNAL_ERROR;
+        memset(ch.ptr, 0, ch.len);
+        freeanychunk(ch);
+
+        if (!build_and_ship_nonce_pk(st, &st->st_ni, &md->rbody,
+          ISAKMP_NEXT_NONE, "<Ni_b>PubKey_r"))
+          return STF_INTERNAL_ERROR;
+      } else {
+        DBG(DBG_PARSING,
+        DBG_log("Shipping nonce_i");
+        );
+        if (!build_and_ship_nonce(&st->st_ni, &md->rbody, 
+          ISAKMP_NEXT_NONE, "Ni"))
+          return STF_INTERNAL_ERROR;
+      }
+    }
+  }
+#endif
 
-    /* Reinsert the state, using the responder cookie we just received */
-    unhash_state(st);
-    memcpy(st->st_rcookie, md->hdr.isa_rcookie, COOKIE_SIZE);
-    insert_state(st);	/* needs cookies, connection, and msgid (0) */
+  /* finish message */
+  close_message(&md->rbody);
 
-    st->st_state = STATE_MAIN_I2;
+  /* Reinsert the state, using the responder cookie we just received */
+  unhash_state(st);
+  memcpy(st->st_rcookie, md->hdr.isa_rcookie, COOKIE_SIZE);
+  insert_state(st);	/* needs cookies, connection, and msgid (0) */
 
-    return STF_REPLY;
+  st->st_state = STATE_MAIN_I2;
+
+  DBG(DBG_PARSING,
+  DBG_log("finished main_inR1_outI2");
+  );
+
+  return STF_REPLY;
 }
 
 /* STATE_MAIN_R1:
@@ -1957,6 +2602,10 @@
     struct state *const st = md->st;
     pb_stream *keyex_pbs = &md->chain[ISAKMP_NEXT_KE]->pbs;
 
+    DBG(DBG_PARSING,
+    DBG_log("in main_inI2_outR2");
+    );
+
     /* KE in */
     RETURN_STF_FAILURE(accept_KE(&st->st_gi, "Gi", st->st_oakley.group, keyex_pbs));
 
@@ -1986,8 +2635,9 @@
     compute_dh_shared(st, st->st_gi, st->st_oakley.group);
 #ifdef DODGE_DH_MISSING_ZERO_BUG
     if (st->st_shared.ptr[0] == 0)
-	return STF_DROP_DOOMED_EXCHANGE;
+        return STF_DROP_DOOMED_EXCHANGE;
 #endif
+
     if (!generate_skeyids_iv(st))
 	return STF_FAIL + AUTHENTICATION_FAILED;
     update_iv(st);
@@ -1995,64 +2645,470 @@
     /* Advance state */
     st->st_state = STATE_MAIN_R2;
 
+    DBG(DBG_PARSING,
+    DBG_log("finished main_inI2_outR2");
+    );
+
     return STF_REPLY;
 }
 
-/* STATE_MAIN_I2:
- * SMF_PSK_AUTH: HDR, KE, Nr --> HDR*, IDi1, HASH_I
- * SMF_DS_AUTH: HDR, KE, Nr --> HDR*, IDi1, [ CERT, ] SIG_I
- *
- * The following are not yet implemented.
- * SMF_PKE_AUTH: HDR, KE, <IDr1_b>PubKey_i, <Nr_b>PubKey_i
- *	    --> HDR*, HASH_I
- * SMF_RPKE_AUTH: HDR, <Nr_b>PubKey_i, <KE_b>Ke_r, <IDr1_b>Ke_r
- *	    --> HDR*, HASH_I
+#ifdef OPENSSL
+/* Handle HDR;KE;<IDii_b>PubKey_r;<Ni_b>PubKey_r from Initiator.
+ * Send a HDR;KE;<IDir_b>PubKey_i;<Nr_b>PubKey_i back.
  */
 stf_status
-main_inR2_outI3(struct msg_digest *md)
+main_inI2_outR2_pk(struct msg_digest *md)
 {
     struct state *const st = md->st;
-    pb_stream *const keyex_pbs = &md->chain[ISAKMP_NEXT_KE]->pbs;
-    int auth_payload = st->st_oakley.auth == OAKLEY_PRESHARED_KEY
-	? ISAKMP_NEXT_HASH : ISAKMP_NEXT_SIG;
+    pb_stream *keyex_pbs = &md->chain[ISAKMP_NEXT_KE]->pbs;
+
+    DBG(DBG_PARSING,
+    DBG_log("in main_inI2_outR2_pk");
+    );
 
     /* KE in */
-    RETURN_STF_FAILURE(accept_KE(&st->st_gr, "Gr", st->st_oakley.group, keyex_pbs));
+    RETURN_STF_FAILURE(accept_KE(&st->st_gi, "Gi", 
+      st->st_oakley.group, keyex_pbs));
 
-    /* Nr in */
-    RETURN_STF_FAILURE(accept_nonce(md, &st->st_nr, "Nr"));
+    if (!decode_peer_id(md, FALSE))
+    return STF_FAIL + INVALID_ID_INFORMATION;
 
-    /* done parsing; initialize crypto  */
+    /* Ni_b<PubKey_r> in */
+    RETURN_STF_FAILURE(accept_nonce(md, &st->st_ni, "<Ni_b>PubKey_r"));
 
-    compute_dh_shared(st, st->st_gr, st->st_oakley.group);
+    /** build output packet HDR;KE;<IDir_b>_PubKey_i;<Nr_b>PubKey_i*********/
+
+    /* HDR out done */
+
+    /* KE out */
+    if (!build_and_ship_KE(st, &st->st_gr, st->st_oakley.group, 
+    &md->rbody, ISAKMP_NEXT_ID))
+	return STF_INTERNAL_ERROR;
+
+    {
+      /* <IDir_b>PubKey_i out */
+      chunk_t ch;
+      
+      if (st->st_connection->this.id.kind == ID_DER_ASN1_DN) {
+        ch.len = st->st_connection->this.id.der_asn1_dn.len + 4;
+        ch.ptr = alloc_bytes(ch.len, "plaintext der_asn1_dn identity");
+        ch.ptr[0] = (u_int8_t)st->st_connection->this.id.kind;
+        memset(&(ch.ptr[1]), 0, 1);
+        memset(&(ch.ptr[2]), 0, 2);
+        memcpy(&(ch.ptr[4]), 
+          st->st_connection->this.id.der_asn1_dn.ptr, 
+          st->st_connection->this.id.der_asn1_dn.len);     
+      } else {
+        ch.len = sizeof(st->st_connection->this.id.ip_addr) + 4;
+        ch.ptr = alloc_bytes(ch.len, "plaintext identity");
+        ch.ptr[0] = (u_int8_t)st->st_connection->this.id.kind;
+        memset(&(ch.ptr[1]), 0, 1);
+        memset(&(ch.ptr[2]), 0, 2);
+        memcpy(&(ch.ptr[4]), &(st->st_connection->this.id.ip_addr),
+          sizeof(st->st_connection->this.id.ip_addr));
+      }
+
+
+      /* PK encrypt this */
+      if (! pubkey_encrypt_chunk( &ch, st )) {
+        return STF_INTERNAL_ERROR;
+      }
+      if (!out_generic_chunk(ISAKMP_NEXT_NONCE, &isakmp_generic_desc, &md->rbody, ch, "my identity (ciphertext)"))
+	return STF_INTERNAL_ERROR;
+      memset(ch.ptr, 0, ch.len);
+      freeanychunk(ch);
+    }
+    
+    /* Nr out */
+    if (!build_and_ship_nonce_pk(st, &st->st_nr, &md->rbody, ISAKMP_NEXT_NONE, "<Nr_b>PubKey_i"))
+      return STF_INTERNAL_ERROR;
+
+    /* finish message */
+    close_message(&md->rbody);
+
+    /* next message will be encrypted, but not this one.
+     * We could defer this calculation.
+     */
+    compute_dh_shared(st, st->st_gi, st->st_oakley.group);
 #ifdef DODGE_DH_MISSING_ZERO_BUG
-    if (st->st_shared.ptr[0] == 0)
-	return STF_REPLACE_DOOMED_EXCHANGE;
+        if (st->st_shared.ptr[0] == 0)
+            return STF_DROP_DOOMED_EXCHANGE;
 #endif
     if (!generate_skeyids_iv(st))
 	return STF_FAIL + AUTHENTICATION_FAILED;
+    update_iv(st);
 
-    /*************** build output packet HDR*;IDii;HASH/SIG_I ***************/
-    /* ??? NOTE: this is almost the same as main_inI3_outR3's code */
+    /* Advance state */
+    st->st_state = STATE_MAIN_R2;
 
-    /* HDR* out done */
+    DBG(DBG_PARSING,
+    DBG_log("finished main_inI2_outR2_pk");
+    );
 
-    /* IDii out */
-    {
-	struct isakmp_ipsec_id id_hd;
-	chunk_t id_b;
-	pb_stream id_pbs;
+    return STF_REPLY;
+}
+#endif /* OPENSSL */
+
+#ifdef OPENSSL
+/* Handle HDR;<Ni_b>Pubkey_r;<KE_b>Ke_i;<IDi1_b>Ke_i[;<cert>Ke_r] from Initiator
+ * Send a HDR;<Nr_b>Pubkey_i;<KE_b>Ke_r;<IDr1_b>Ke_r[;<cert>Ke_r] back.
+ */
+stf_status
+main_inI2_outR2_rpk(struct msg_digest *md)
+{
+    struct state *const st = md->st;
+    pb_stream *keyex_pbs = &md->chain[ISAKMP_NEXT_KE]->pbs;
+
+    DBG(DBG_PARSING,
+    DBG_log("in main_inI2_outR2_rpk");
+    );
+
+    /* Ni_b<PubKey_r> in */
+    RETURN_STF_FAILURE(accept_nonce(md, &st->st_ni, "<Ni_b>PubKey_r"));
+
+    /* KE<Ke_r> in */
+    RETURN_STF_FAILURE(accept_KE(&st->st_gi, "Gi", 
+      st->st_oakley.group, keyex_pbs));
+
+    if (!decode_peer_id(md, FALSE))
+      return STF_FAIL + INVALID_ID_INFORMATION;
+
+    /**************** build output packet ****************/
+
+    /* HDR out done */
+
+    /* Nr out */
+    if (!build_and_ship_nonce_pk(st, &st->st_nr, &md->rbody, 
+      ISAKMP_NEXT_KE, "<Nr_b>PubKey_i")) 
+      return STF_INTERNAL_ERROR;
+
+    if (derive_symmetric_key(st, st->st_nr,
+			     st->st_rcookie, COOKIE_SIZE,
+			     &st->st_ks_r,
+			     &st->st_ne_r) < 0) {
+      log("error while deriving symmetric key in revised mode");
+      return STF_INTERNAL_ERROR;
+    }
+    memset(st->st_ne_r_iv, 0, MAX_DIGEST_LEN);
+
+    DBG(DBG_PARSING,
+    DBG_dump_chunk("Generated Ke_r:", st->st_ne_r);
+    );
+
+    /* KE out */
+    if (!build_and_ship_KE_rpk(st, FALSE, &st->st_gr, st->st_oakley.group
+			       , &md->rbody, ISAKMP_NEXT_ID))
+      return STF_INTERNAL_ERROR;
+
+    /* <IDr1_b>Ke_r[<cert>Ke_r] out */
+    {
+      chunk_t ch, out;
+
+      if (st->st_connection->this.id.kind == ID_DER_ASN1_DN) {
+        ch.len = st->st_connection->this.id.der_asn1_dn.len + 4;
+        ch.ptr = alloc_bytes(ch.len, "encrypted der_asn1_dn identity");
+        ch.ptr[0] = (u_int8_t)st->st_connection->this.id.kind;
+        memset(&(ch.ptr[1]), 0, 1);
+        memset(&(ch.ptr[2]), 0, 2);
+        memcpy(&(ch.ptr[4]), 
+          st->st_connection->this.id.der_asn1_dn.ptr, 
+          st->st_connection->this.id.der_asn1_dn.len);     
+      } else {
+        ch.len = sizeof(st->st_connection->this.id.ip_addr) + 4;
+        ch.ptr = alloc_bytes(ch.len, "encrypted identity");
+        ch.ptr[0] = (u_int8_t)st->st_connection->this.id.kind;
+        memset(&(ch.ptr[1]), 0, 1);
+        memset(&(ch.ptr[2]), 0, 2);
+        memcpy(&(ch.ptr[4]), &(st->st_connection->this.id.ip_addr),
+          sizeof(st->st_connection->this.id.ip_addr));
+      }
+
+      if (!encrypt_payload(st, &st->st_ks_r, st->st_ne_r_iv,
+        ch, &out))
+      return STF_INTERNAL_ERROR;
+      freeanychunk(ch);
+
+      /* Are we going to send CERT? */
+      if ((st->st_connection->cert_options & CERT_OPTION_SEND) == 0) {
+        if (!out_generic_chunk(ISAKMP_NEXT_NONE, &isakmp_generic_desc,
+          &md->rbody, out, "my identity (ciphertext)")) 
+        {
+	  freeanychunk(out);
+	  return STF_INTERNAL_ERROR;
+        }
+      } else {
+        if (!out_generic_chunk(ISAKMP_NEXT_CERT, &isakmp_generic_desc,
+          &md->rbody, out, "my identity (ciphertext)")) 
+        {
+	  freeanychunk(out);
+	  return STF_INTERNAL_ERROR;
+        }
+      }
+      freeanychunk(out);
+    }
+
+        /* Well, if we do send CERT, let's start on it from here */
+        if ((st->st_connection->cert_options & CERT_OPTION_SEND) != 0) {
+
+          chunk_t crt, cx, out;
+          unsigned long ulen;
+          /* Send the signing certificate */
+
+          ulen = i2d_X509(st->st_connection->cert, NULL);
+          ulen++;
+          if ((cx.ptr = alloc_bytes(ulen, "ASN.1 cert")) == NULL)
+          { 
+            return STF_INTERNAL_ERROR; 
+          }
+          (cx.ptr)[0] = (u_char)(CERT_TYPE_X509_SIG);
+          cx.len = ulen;
+          crt.ptr = &(cx.ptr[1]);
+          crt.len = i2d_X509(st->st_connection->cert, &(crt.ptr));
+
+          DBG(DBG_CRYPT,
+          DBG_log("plaintext Certificate length: %d", cx.len);
+          DBG_dump_chunk("plaintext Certificate", cx);
+          );
+
+          /* encrypt the certificate to send */
+          if (!encrypt_payload(st, &st->st_ks_r, st->st_ne_r_iv,
+            cx, &out))
+          return STF_INTERNAL_ERROR;
+
+          DBG(DBG_CRYPT,
+          DBG_log("cyphertext Certificate length: %d", out.len);
+          DBG_dump_chunk("cyphertext Certificate", out);
+          );
+
+          if (!out_generic_chunk(ISAKMP_NEXT_NONE, 
+            &isakmp_ipsec_certificate_desc,
+            &md->rbody, out, "my certificate (ciphertext)")) 
+          {
+            freeanychunk(out);
+            return STF_INTERNAL_ERROR;
+          }
+        }
+        /* end of sending out cert */
+    
+    /* finish message */
+    close_message(&md->rbody);
+
+    /* next message will be encrypted, but not this one.
+     * We could defer this calculation.
+     */
+    compute_dh_shared(st, st->st_gi, st->st_oakley.group);
+#ifdef DODGE_DH_MISSING_ZERO_BUG
+    if (st->st_shared.ptr[0] == 0)
+        return STF_DROP_DOOMED_EXCHANGE;
+#endif
+    if (!generate_skeyids_iv(st))
+	return STF_FAIL + AUTHENTICATION_FAILED;
+    update_iv(st);
+
+    /* Advance state */
+    st->st_state = STATE_MAIN_R2;
+
+    DBG(DBG_PARSING,
+    DBG_log("finished main_inI2_outR2_rpk");
+    );
+
+    return STF_REPLY;
+}
+#endif /* OPENSSL */
+
+
+/* STATE_MAIN_I2:
+ * SMF_PSK_AUTH: HDR, KE, Nr --> HDR*, IDi1, HASH_I
+ * SMF_DS_AUTH: HDR, KE, Nr --> HDR*, IDi1, [ CERT, ] SIG_I
+ *
+ * The following are not yet implemented.
+ * SMF_PKE_AUTH: HDR, KE, <IDr1_b>PubKey_i, <Nr_b>PubKey_i
+ *	    --> HDR*, HASH_I
+ * SMF_RPKE_AUTH: HDR, <Nr_b>PubKey_i, <KE_b>Ke_r, <IDr1_b>Ke_r
+ *	    --> HDR*, HASH_I
+ */
+stf_status
+main_inR2_outI3(struct msg_digest *md)
+{
+    struct state *const st = md->st;
+#ifdef OPENSSL
+    struct connection *c = st->st_connection;
+#endif
+
+    pb_stream *const keyex_pbs = &md->chain[ISAKMP_NEXT_KE]->pbs;
+
+    int auth_payload = st->st_oakley.auth == OAKLEY_PRESHARED_KEY
+	? ISAKMP_NEXT_HASH : ISAKMP_NEXT_SIG;
+
+    DBG(DBG_PARSING,
+    DBG_log("in main_inR2_outI3");
+    );
+
+    /* KE in */
+    RETURN_STF_FAILURE(accept_KE(&st->st_gr, "Gr", 
+		st->st_oakley.group, keyex_pbs));
+
+    /* Nr in */
+    RETURN_STF_FAILURE(accept_nonce(md, &st->st_nr, "Nr"));
+
+    /* done parsing; initialize crypto  */
+
+    compute_dh_shared(st, st->st_gr, st->st_oakley.group);
+#ifdef DODGE_DH_MISSING_ZERO_BUG
+    if (st->st_shared.ptr[0] == 0)
+        return STF_REPLACE_DOOMED_EXCHANGE;
+#endif
+    if (!generate_skeyids_iv(st))
+	return STF_FAIL + AUTHENTICATION_FAILED;
+
+    /*************** build output packet HDR*;IDii;HASH/SIG_I ***************/
+
+    /* HDR* out done */
+
+    /* IDii out */
+    {
+	struct isakmp_ipsec_id id_hd;
+	chunk_t id_b;
+	pb_stream id_pbs;
+
+	build_id_payload(&id_hd, &id_b, &st->st_connection->this);
+#ifdef OPENSSL
+if (use_openssl(st->st_connection)) 
+{
+  switch(st->st_oakley.auth) {
+  case OAKLEY_RSA_SIG:
+  case OAKLEY_DSS_SIG:
+    if ((c->cert_options & CERT_OPTION_SEND) == 0)
+      id_hd.isaiid_np = ISAKMP_NEXT_SIG;
+    else
+      id_hd.isaiid_np = ISAKMP_NEXT_CERT;
+    break;
+  case OAKLEY_RSA_ENC:
+  case OAKLEY_RSA_ENC_REV:
+    log("RSA method not supported yet");
+    return STF_INTERNAL_ERROR;
+    break;
+  default:
+    id_hd.isaiid_np = ISAKMP_NEXT_HASH;
+    break;
+  }
+}
+else
+{
+#endif /* OPENSSL */
+	id_hd.isaiid_np = auth_payload;
+#ifdef OPENSSL
+}
+#endif /* OPENSSL */
 
-	build_id_payload(&id_hd, &id_b, &st->st_connection->this);
-	id_hd.isaiid_np = auth_payload;
 	if (!out_struct(&id_hd, &isakmp_ipsec_identification_desc, &md->rbody, &id_pbs)
-	|| !out_chunk(id_b, &id_pbs, "my identity"))
-	    return STF_INTERNAL_ERROR;
+		|| !out_chunk(id_b, &id_pbs, "my identity")) 
+		return STF_INTERNAL_ERROR;
 	close_output_pbs(&id_pbs);
+    } /* IDii out done */
+
+#ifdef OPENSSL
+if (use_openssl(st->st_connection)) 
+{
+    if (((c->cert_options & CERT_OPTION_SEND) != 0) &&
+  ((st->st_oakley.auth == OAKLEY_RSA_SIG) ||
+   (st->st_oakley.auth == OAKLEY_DSS_SIG))) {
+      u_char *crt, *cx;
+      unsigned long ulen;
+      /* Send the signing certificate */
+
+      ulen = i2d_X509(c->cert, NULL);
+      ulen++;
+      if ((cx = alloc_bytes(ulen, "ASN.1 cert")) == NULL)
+  { return STF_INTERNAL_ERROR; }
+      cx[0] = (u_char)(CERT_TYPE_X509_SIG);
+      crt = &(cx[1]);
+      i2d_X509(c->cert, &crt);
+      if (!out_generic_raw(ISAKMP_NEXT_SIG, &isakmp_ipsec_certificate_desc
+             , &md->rbody, cx, ulen, "CERT_I"))
+  return STF_INTERNAL_ERROR;
+      pfree(cx);
     }
 
-    /* HASH_I or SIG_I out */
-    {
+  /* HASH_I out, OPENSSL */
+  {
+	u_char hash_val[MAX_DIGEST_LEN];
+	size_t hash_len = main_mode_hash(st, hash_val, TRUE, TRUE);
+    u_char *buf;
+    u_int elen;
+    bool ok;
+
+  /* Output the signature/hash as defined by the selected Oakley transform */
+
+  switch (st->st_oakley.auth) {
+  case OAKLEY_RSA_SIG: /* output signed HASH_I */
+    if ((buf = alloc_bytes(EVP_PKEY_size(c->key) + 32 /* bit of slack */,
+               "RSA signature")) == NULL)
+        return STF_INTERNAL_ERROR;
+    elen = RSA_private_encrypt(hash_len, hash_val, buf,
+                   ((EVP_PKEY *)(c->key))->pkey.rsa,
+                   RSA_PKCS1_PADDING);
+    if (!out_generic_raw(ISAKMP_NEXT_NONE, &isakmp_signature_desc, &md->rbody
+                 , buf, elen, "SIG_I"))
+      return STF_INTERNAL_ERROR;
+    pfree(buf);
+   
+	DBG(DBG_PARSING,
+	    DBG_log("Selected auth mechanism is %s",
+        	enum_show(&oakley_auth_names, st->st_oakley.auth));
+	)
+    break;
+
+  case OAKLEY_DSS_SIG:
+    /* We don't have to check whether the hash is a SHA1 */
+    /* one, since the ciphersuite offering DSA is only */
+    /* configured with SHA1. Don't change this configuration */
+    if (c->cert_options & CERT_OPTION_DSS_SHA)
+      main_mode_sha1(st, hash_val, &hash_len, TRUE, TRUE);
+
+    buf = alloc_bytes(EVP_PKEY_size(c->key) + 32 /* bit of slack */,
+              "DSA signature");
+    if (buf) {
+      ok = (c->cert_options & CERT_OPTION_DSS_ALT)
+        ? DSA_sign_raw(hash_val, hash_len,
+               buf, &elen, ((EVP_PKEY *)(c->key))->pkey.dsa)
+        : DSA_sign(EVP_PKEY_DSA, hash_val, hash_len,
+           buf, &elen, ((EVP_PKEY *)(c->key))->pkey.dsa);
+      if (!ok) {
+        /* DSA signing failed */
+        log_err();
+        return STF_INTERNAL_ERROR;
+      }
+      if (!out_generic_raw(ISAKMP_NEXT_NONE, &isakmp_signature_desc,
+               &md->rbody, buf, elen, "SIG_I"))
+        return STF_INTERNAL_ERROR;
+      pfree(buf);
+    } else
+      return STF_INTERNAL_ERROR;
+   
+	DBG(DBG_PARSING | DBG_CONTROL, 
+	DBG_log("Selected auth mechanism is %s",
+	  enum_show(&oakley_auth_names, st->st_oakley.auth));
+	);
+    break;
+    /* If we get to any of these, something has gone WAY wrong */
+  case OAKLEY_RSA_ENC:
+    return STF_INTERNAL_ERROR;
+  case OAKLEY_ELGAMAL_ENC:
+    return STF_INTERNAL_ERROR;
+  case OAKLEY_RSA_ENC_REV:
+    return STF_INTERNAL_ERROR;
+  case OAKLEY_ELGAMAL_ENC_REV:
+    return STF_INTERNAL_ERROR;
+  default:
+	} /* switch done */
+  } /* HASH_I out, openssl done. */
+}
+else
+{
+#endif /* OPENSSL */
+  /* HASH_I or SIG_I out, !OPENSSL */
+  {
 	u_char hash_val[MAX_DIGEST_LEN];
 	size_t hash_len = main_mode_hash(st, hash_val, TRUE, TRUE);
 
@@ -2067,8 +3123,8 @@
 	{
 	    /* SIG_I out */
 	    u_char sig_val[RSA_MAX_OCTETS];
-	    size_t sig_len = RSA_sign_hash(st->st_connection
-		, sig_val, hash_val, hash_len);
+	    size_t sig_len = RSA_sign_hash(st->st_connection, 
+			sig_val, hash_val, hash_len);
 
 	    if (sig_len == 0)
 	    {
@@ -2080,7 +3136,10 @@
 	    , &md->rbody, sig_val, sig_len, "SIG_I"))
 		return STF_INTERNAL_ERROR;
 	}
-    }
+  }
+#ifdef OPENSSL
+}
+#endif /* OPENSSL */
 
     /* encrypt message, except for fixed part of header */
 
@@ -2091,8 +3150,162 @@
     /* Advance state */
     st->st_state = STATE_MAIN_I3;
 
+    DBG(DBG_PARSING,
+    DBG_log("finished main_inR2_outI3");
+    );
+
+    return STF_REPLY;
+}
+
+#ifdef OPENSSL
+/*
+ * Handle HDR;KE;<IDir_b>PubKey_i;<Nr_b>PubKey_i from responder.
+ * Send a HDR*;HASH_I back.
+ */
+stf_status main_inR2_outI3_pk(struct msg_digest *md)
+{
+    struct state *const st = md->st;
+    pb_stream *const keyex_pbs = &md->chain[ISAKMP_NEXT_KE]->pbs;
+
+    DBG(DBG_PARSING,
+    DBG_log("in main_inR2_outI3_pk");
+    );
+
+    /* KE in */
+    RETURN_STF_FAILURE(accept_KE(&st->st_gr, "Gr", 
+	st->st_oakley.group, keyex_pbs));
+
+    /* IDir in */
+    if (!decode_peer_id(md, TRUE))
+    return STF_FAIL + INVALID_ID_INFORMATION;
+
+    /* Nr in */
+    RETURN_STF_FAILURE(accept_nonce(md, &st->st_nr, "<Nr_b>PubKey_i"));
+
+    /* done parsing; initialize crypto  */
+
+    compute_dh_shared(st, st->st_gr, st->st_oakley.group);
+#ifdef DODGE_DH_MISSING_ZERO_BUG
+    if (st->st_shared.ptr[0] == 0)
+        return STF_REPLACE_DOOMED_EXCHANGE;
+#endif
+    if (!generate_skeyids_iv(st))
+    return STF_FAIL + AUTHENTICATION_FAILED;
+
+    /**************** build output packet HDR*;HASH_I ****************/
+
+    /* HDR* out done */
+
+    /* HASH_I out */
+    {
+  u_char hash_val[MAX_DIGEST_LEN];
+  size_t hash_len = main_mode_hash(st, hash_val, TRUE, TRUE);
+
+  if (!out_generic_raw(ISAKMP_NEXT_NONE, &isakmp_hash_desc, &md->rbody
+  , hash_val, hash_len, "HASH_I"))
+      return STF_INTERNAL_ERROR;
+    }
+
+    /* encrypt message, except for fixed part of header */
+
+    /* st_new_iv was computed by generate_skeyids_iv */
+    if (!encrypt_message(&md->rbody, st))
+    return STF_INTERNAL_ERROR;  /* ??? we may be partly committed */
+
+    /* Advance state */
+    st->st_state = STATE_MAIN_I3;
+
+    DBG(DBG_PARSING,
+    DBG_log("finished main_inR2_outI3_pk");
+    );
+
     return STF_REPLY;
 }
+#endif /* OPENSSL */
+
+#ifdef OPENSSL
+/* Handle HDR;KE;<Nr_b>PubKey_i;<KE_b>Ke_r;<IDr1_b>Ke_r from responder.
+ * Send a HDR*;HASH_I back.
+ */
+stf_status
+main_inR2_outI3_rpk(struct msg_digest *md)
+{
+    struct state *const st = md->st;
+    pb_stream *const keyex_pbs = &md->chain[ISAKMP_NEXT_KE]->pbs;
+
+    DBG(DBG_PARSING,
+    DBG_log("in main_inR2_outI3_rpk");
+    );
+
+    /* Nr in */
+    RETURN_STF_FAILURE(accept_nonce(md, &st->st_nr, "<Nr_b>PubKey_i"));
+
+    /* KE in */
+    RETURN_STF_FAILURE(accept_KE(&st->st_gr, "Gr", 
+      st->st_oakley.group, keyex_pbs));
+
+    /* IDir in */
+    if (!decode_peer_id(md, TRUE))
+      return STF_FAIL + INVALID_ID_INFORMATION;
+
+    /* done parsing; initialize crypto  */
+
+    compute_dh_shared(st, st->st_gr, st->st_oakley.group);
+#ifdef DODGE_DH_MISSING_ZERO_BUG
+    if (st->st_shared.ptr[0] == 0)
+        return STF_REPLACE_DOOMED_EXCHANGE;
+#endif
+    if (!generate_skeyids_iv(st))
+  return STF_FAIL + AUTHENTICATION_FAILED;
+
+    /**************** build output packet HDR*;HASH_I ****************/
+
+    /* HDR* out done */
+
+    /* HASH_I out */
+    {
+      u_char hash_val[MAX_DIGEST_LEN];
+
+      size_t hash_len = main_mode_hash(st, hash_val, TRUE, TRUE);
+
+      if (!out_generic_raw(ISAKMP_NEXT_NONE, &isakmp_hash_desc, &md->rbody, 
+        hash_val, hash_len, "HASH_I"))
+      return STF_INTERNAL_ERROR;
+    }
+
+    /* encrypt message, except for fixed part of header */
+
+    /* st_new_iv was computed by generate_skeyids_iv */
+    if (!encrypt_message(&md->rbody, st))
+    return STF_INTERNAL_ERROR;  /* ??? we may be partly committed */
+
+    /* Advance state */
+    st->st_state = STATE_MAIN_I3;
+
+    DBG(DBG_PARSING,
+    DBG_log("fnished main_inR2_outI3_rpk");
+    );
+
+    return STF_REPLY;
+}
+#endif /* OPENSSL */
+
+
+#ifdef OPENSSL
+/* STATE_MAIN_R2:
+ * Which type of DS are we currently handling?
+ * Classic? OPENSSL?
+ */
+stf_status
+main_inI3_outR3_whichds(struct msg_digest *md)
+{ 
+	if (! use_openssl(md->st->st_connection)) {
+		return main_inI3_outR3(md);
+	} else {
+		return main_inI3_outR3_ds(md);
+	}
+}
+#endif /* OPENSSL */
 
 /* STATE_MAIN_R2:
  * PSK_AUTH: HDR*, IDi1, HASH_I --> HDR*, IDr1, HASH_R
@@ -2101,11 +3314,16 @@
  */
 stf_status
 main_inI3_outR3(struct msg_digest *md)
-{
+{ 
     struct state *const st = md->st;
+
     int auth_payload = st->st_oakley.auth == OAKLEY_PRESHARED_KEY
 	? ISAKMP_NEXT_HASH : ISAKMP_NEXT_SIG;
 
+    DBG(DBG_PARSING,
+    DBG_log("in main_inI3_outR3");
+    );
+
     /* input code similar to main_inR3 -- should be factored */
 
     /* IDii in */
@@ -2192,6 +3410,10 @@
     struct state *const st = md->st;
     struct connection *c = st->st_connection;
 
+    DBG(DBG_PARSING,
+    DBG_log("in main_inR3");
+    );
+
     /* input code similar to main_inI3_outR3 -- should be factored */
 
     /* IDir in */
